from setuphelpers import *
from setupdevhelpers import *
import re
import requests

def update_package():
    # Déclaration des variables locales
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    
     # Obtenir la dernière version à partir des sources officielles
    re_versions = re.compile(r'<a href="emacs-([\d\.]+)/">')
    re_installers = re.compile(r'<a href="(emacs-[\d\.]+-installer\.exe)">')

    base_url = "https://mirror.cyberbits.eu/gnu/emacs/windows/"
    index = wgets(base_url, proxies=proxies)

    # Trouver la dernière version d'Emacs
    version = None
    latest_bin = None

    for versionemacs in sorted(re_versions.findall(index), key=lambda p: Version(p), reverse=True):
        version_url = f"{base_url}emacs-{versionemacs}/"
        version_index = wgets(version_url, proxies=proxies)

        # Trouver le dernier installateur dans le répertoire de la version
        install_files = re_installers.findall(version_index)
        if install_files:
            latest_bin = max(install_files, key=lambda p: Version(re.search(r"emacs-(\d+\.\d+)", p).group(1)))
            download_url = f"{version_url}{latest_bin}"

            # Vérifier si l'URL de téléchargement est valide
            if requests.head(download_url, proxies=proxies).status_code != 404:
                version = download_url.split("-")[-2]
                break

    if not version or not latest_bin:
        raise ValueError("Impossible de trouver la dernière version ou l'installateur.")

    print(f"Dernière version trouvée : emacs-{version}")
    print(f"URL de téléchargement de l'installateur : {download_url}")


    # Supprimer les anciens fichiers installateurs
    for f in glob.glob("*.exe"):
        if f != latest_bin:
            remove_file(f)

    # Télécharger le dernier installateur
    wget(download_url, latest_bin, proxies=proxies)

    

    # Mettre à jour la version du logiciel dans le fichier de contrôle
    control.set_software_version(version)
    control.save_control_to_wapt()

